####Test FGENESB frame calculation ##############
use strict;
use warnings;
use orf_comp;

print STDERR "Enter GeneMarkHMM prediction file name\n";
my $genmark_file=<STDIN>;
print STDERR"Enter Prodigal file name\n";
my $prodigal_file=<STDIN>;
print STDERR"Enter FGENESB file name\n";
my $fgen_file=<STDIN>;
print STDERR"Enter Glimmer file name\n";
my $glimmer_file=<STDIN>;
print STDERR"Enter Genome length in bp\n";
my $genome_length=<STDIN>;
chomp($genmark_file,$prodigal_file,$fgen_file,$glimmer_file,$genome_length);
my @genemark_frame_calculated_data=Genmark_frame_calculate($genmark_file,$genome_length);
#print "GENMARK\n\n",join("\n",@genemark_frame_calculated_data),"\n";
my @prodigal_frame_calculated_data=prodigal_frame_calculate($prodigal_file,$genome_length);
#print "PRODIGAL\n\n",join("\n",@prodigal_frame_calculated_data),"\n";
my @glimmer_frame_calculated_data=Glimmer_frame_calculate($glimmer_file,$genome_length);
#print "GLIMMER\n\n",join("\n",@glimmer_frame_calculated_data),"\n";
my @fgen_frame_calculated_data=FGENESB_frame_calculate($fgen_file,$genome_length);
#print "FGENESB\n\n",join("\n",@fgen_frame_calculated_data),"\n\n";
print STDERR"Enter co-ordinate(bp) file(GFF)\n";
my $gff_file=<STDIN>;
open(IN,$gff_file) or die("Can not open $gff_file");
	my %orf_mapped=();
	my %orf_coordinates=();
	while(my $line=<IN>)
	{
		chomp $line;
		my @line_data=split(/\t/,$line);
		my $protein_id=$line_data[2];
		$protein_id=~s/\s|\r|\n//g;
		my $flag=0;
		my @locus_info=split('_',$protein_id);
		if((scalar(@line_data)<9)||($line_data[3]=~/[^\d]/))
		{
			next;
		}

		foreach my $orf(@genemark_frame_calculated_data)
		{
			my @orf_values=split(/\t/,$orf);
			my $frame=$orf_values[4];
			if($locus_info[3] == $frame)
			{
				my $s2=$orf_values[1];
				my $e2=$orf_values[2];
				$e2=~s/[^0-9]//g;
				$e2=~s/\s|\r|\n//g;
				$s2=~s/[^0-9]//g;
				$s2=~s/\s|\r|\n//g;
				if($frame <0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];

					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'genmark'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
				if($frame >0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];
					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'genmark'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
			}
		}
		if($flag==0)
		{
			$orf_mapped{$protein_id}{'genmark'}=0;
		}
		else
		{
			$orf_mapped{$protein_id}{'genmark'}=1;
		}
		if(!(defined($orf_coordinates{$protein_id}{'genmark'})))
		{
			$orf_coordinates{$protein_id}{'genmark'}='-';
		}

		$flag=0;
		foreach my $orf(@glimmer_frame_calculated_data)
		{
			my @orf_values=split(/\t/,$orf);
			my $frame=$orf_values[4];
			if($locus_info[3] == $frame)
			{
				my $s2=$orf_values[1];
				my $e2=$orf_values[2];
				$e2=~s/[^0-9]//g;
				$e2=~s/\s|\r|\n//g;
				$s2=~s/[^0-9]//g;
				$s2=~s/\s|\r|\n//g;
				if($frame <0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];

					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'glimmer'}=$s2.'_'.$e2.'_'.$frame;

						$flag=1;
					}
				}
				if($frame >0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];
					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'glimmer'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
			}
		}
		if($flag==0)
		{
			$orf_mapped{$protein_id}{'glimmer'}=0;
		}
		else
		{
			$orf_mapped{$protein_id}{'glimmer'}=1;
		}
		if(!(defined($orf_coordinates{$protein_id}{'glimmer'})))
		{
			$orf_coordinates{$protein_id}{'glimmer'}='-';
		}
		$flag=0;
		foreach my $orf(@fgen_frame_calculated_data)
		{
			my @orf_values=split(/\t/,$orf);
			my $frame=$orf_values[4];
			if($locus_info[3] == $frame)
			{
				my $s2=$orf_values[1];
				my $e2=$orf_values[2];
				$e2=~s/[^0-9]//g;
				$e2=~s/\s|\r|\n//g;
				$s2=~s/[^0-9]//g;
				$s2=~s/\s|\r|\n//g;
				if($frame <0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];

					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'fgenesb'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
				if($frame >0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];
					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'fgenesb'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
			}
		}
		if($flag==0)
		{
			$orf_mapped{$protein_id}{'fgenesb'}=0;
		}
		else
		{
			$orf_mapped{$protein_id}{'fgenesb'}=1;
		}
		if(!(defined($orf_coordinates{$protein_id}{'fgenesb'})))
		{
			$orf_coordinates{$protein_id}{'fgenesb'}='-';
		}
		$flag=0;
		foreach my $orf(@prodigal_frame_calculated_data)
		{
			my @orf_values=split(/\t/,$orf);
			my $frame=$orf_values[4];
			if($locus_info[3] == $frame)
			{
				my $s2=$orf_values[1];
				my $e2=$orf_values[2];
				$e2=~s/[^0-9]//g;
				$e2=~s/\s|\r|\n//g;
				$s2=~s/[^0-9]//g;
				$s2=~s/\s|\r|\n//g;
				if($frame <0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];

					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'prodigal'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
				if($frame >0)
				{
					my $s1=$line_data[3];
					my $e1=$line_data[4];
					if(($e1>$s2)&&($e2>$s1))
					{
						#print $line,"\t",$orf,"\n";
						#push(@orf_mapped,$line."\t".$orf);
						$orf_coordinates{$protein_id}{'prodigal'}=$s2.'_'.$e2.'_'.$frame;
						$flag=1;
					}
				}
			}
		}
		if($flag==0)
		{
			$orf_mapped{$protein_id}{'prodigal'}=0;
		}
		else
		{
			$orf_mapped{$protein_id}{'prodigal'}=1;
		}
		if(!(defined($orf_coordinates{$protein_id}{'prodigal'})))
		{
			$orf_coordinates{$protein_id}{'prodigal'}='-';
		}
	} 
print "\tGENMARK\tPRODIGAL\tGLIMMER\tFGENESB\n";
foreach my $key (keys(%orf_mapped))
	{
		print $key,"\t",$orf_mapped{$key}{'genmark'},"\t",$orf_mapped{$key}{'prodigal'},"\t",$orf_mapped{$key}{'glimmer'},"\t",$orf_mapped{$key}{'fgenesb'},"\n";
	}
#foreach my $key (keys(%orf_coordinates))
#	{
#		print $key,"\t",$orf_coordinates{$key}{'genmark'},"\t",$orf_coordinates{$key}{'prodigal'},"\t",$orf_coordinates{$key}{'glimmer'},"\t",$orf_coordinates{$key}{'fgenesb'},"\n";
#
#	}
foreach my $key (keys(%orf_coordinates))
	{
		my %start=();
		my @protein_data=split('_',$key);
		my $strand=$protein_data[3];
		my $end=$protein_data[2];
		my $st='';
		if($strand<0)
		{
			$end=$protein_data[2];
		}
		foreach my $tag (keys(%{$orf_coordinates{$key}}))
			{
			if($strand<0)
				{
					my @data=split('_',$orf_coordinates{$key}{$tag});
					if(scalar(@data)<2)
					{
						next;
					}
					else
					{
						if(defined($start{$data[1]}))
						{
							$start{$data[1]}++;
						}
						else
						{
							$start{$data[1]}=1;
						}
					}
				
				}
			else
				{			
					my @data=split('_',$orf_coordinates{$key}{$tag});
					if(scalar(@data)<2)
					{
						next;
					}
					else
					{
						if(defined($start{$data[0]}))
						{
							$start{$data[0]}++;
						}
						else
						{
							$start{$data[0]}=1;
						}
					}
				
				}
			}
		if(scalar(keys(%start))==0)
		{
			$st='-';
		}
		elsif(scalar(keys(%start))==1)
		{
			my @st_cods=keys(%start);
			$st=$st_cods[0];
		}
		else
		{

			my @sorted_start=();
			my $j=0;
			foreach my $val (keys(%start))
				{
					$sorted_start[$j][0]=$val;
					$sorted_start[$j][1]=$start{$val};
					$j++;
				}			
			@sorted_start=sort{$b->[1]<=>$a->[1]}@sorted_start;
			if($sorted_start[0][1]==$sorted_start[1][1])
			{
				my $length=0;
				$st=0;
				foreach my $start_co(keys(%start))
					{
						if(abs($end-$start_co)>$length)
						{
							$st=$start_co;
							$length=abs($end-$start_co);
						}
					}
			}
			else
			{				
				$st=$sorted_start[0][0];
			}
		}
print $key,"\t",$orf_coordinates{$key}{'genmark'},"\t",$orf_coordinates{$key}{'prodigal'},"\t",$orf_coordinates{$key}{'glimmer'},"\t",$orf_coordinates{$key}{'fgenesb'},"\t",$st,"\t",$end,"\t",$strand,"\n";
	}